//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpMsg.h"
#include "Pgp.h"
//---------------------------------------------------------------------------
__fastcall TPgpMsg::TPgpMsg(TStrings *AsciiMessage)
{
   status = 0;
   buf = buf_new();
   BUFFER *armor=buf_new(); buf_sets(armor,AsciiMessage->Text.c_str());
   status = pgp_dearmor(armor,buf);
}
//---------------------------------------------------------------------------
__fastcall TPgpMsg::TPgpMsg(BUFFER *Message)
{
   status = 0;
   buf = buf_new();
   BUFFER *armor=buf_new(); buf_set(armor,Message);
   if (!pgp_ispacket(buf)) status = pgp_dearmor(armor,buf);
   else buf_move(buf,armor);
}
//---------------------------------------------------------------------------
__fastcall TPgpMsg::TPgpMsg(char* Message)
{
   status = 0;
   buf = buf_new();
   BUFFER *armor=buf_new(); buf_sets(armor,Message);
   if (!pgp_ispacket(buf)) status = pgp_dearmor(armor,buf);
   else buf_move(buf,armor);
}
//---------------------------------------------------------------------------
__fastcall TPgpMsg::~TPgpMsg()
{
   buf_free(buf);
}
//---------------------------------------------------------------------------
void __fastcall TPgpMsg::KeyId(BUFFER *Keyid, BUFFER *pkt)
{
   if (Keyid) buf_append(Keyid,&pkt->data[1],8);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpMsg::idtext8(BUFFER *pkt)
{
 	 byte c;
   AnsiString text8;
   BUFFER *id = buf_new();
   KeyId(id,pkt);
	 for (int i=0; i<4; i++)
   {
 	  	 c = id->data[4+i];
		 text8 += "0123456789ABCDEF" [ c >> 4  ];
		 text8 += "0123456789ABCDEF" [ c & 0xf ];
	 }
   buf_free(id);
   return text8;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpMsg::IdText8()
{
   int type;
   AnsiString id;
   buf_rewind(buf);
   BUFFER *p = buf_new();
   while ((type = pgp_getpacket(buf, p)) > 0)
   {
      if (type==1)
      {
         if (!id.IsEmpty()) id += "\r\n";
         id += idtext8(p);
      }
   }
   return id;
}
//---------------------------------------------------------------------------
void __fastcall TPgpMsg::GetMsgInfo()
{
/*   TStringList *lines = new TStringList();
   int type;
   buf_rewind(buf);
   BUFFER *p = buf_new();
   while ((type = pgp_getpacket(buf, p)) > 0)
   {
//lines->Add(Version(p));
//lines->Add(IdText8(p));
   }
//sm(lines->Text);
   delete lines; */
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpMsg::Description(BUFFER *pkt)
{
   AnsiString descrip;
//     s("CBT:  ")+CTB(pkt)+s("\n")+
//     s("LoL:  ")+s(LengthOfLength(pkt))+s("\n")+
//     s("Lod:  ")+s((int)LengthOfData(pkt))+s("\n")+
//     s("Ver:  ")+s(Version(pkt))+s("\n")+
//     s("Key:  ")+IdText8(pkt);
   return descrip;
}
//---------------------------------------------------------------------------
/*long __fastcall TPgpMsg::LengthOfData(BUFFER *pkt)
{
   if (!pkt) pkt = buf;
   long l,lod=0;
   BYTE *b=(BYTE*)&l;
   UINT *w=(UINT*)&l;
   buf_rewind(buf); buf_getc(pkt);
   switch (LengthOfLength(pkt))
   {
      case 1:
         l = buf_getc(pkt);
         lod = *b;
         break;
      case 2:
         l = buf_geti(pkt);
         lod = *w;
         break;
      case 4:
         l = buf_getl(pkt);
         lod = l;
         break;
   }
   return lod;
}*/
//---------------------------------------------------------------------------
/*byte __fastcall TPgpMsg::CTB(BUFFER *pkt)
{
   return pkt->data[0]; // CTB=132 (10000100)
}*/
//---------------------------------------------------------------------------
/*byte __fastcall TPgpMsg::LengthOfLength(BUFFER *pkt)
{
   if ((CTB(pkt) & 1) == 1) return 2;
   if ((CTB(pkt) & 2) == 2) return 4;
   if ((CTB(pkt) & 3) == 3) return 0;
   return 1;
}*/
//---------------------------------------------------------------------------
byte __fastcall TPgpMsg::Algorithm(BUFFER *pkt)
{
   return pkt->data[9]; // RSA=1
}
//---------------------------------------------------------------------------
byte __fastcall TPgpMsg::Version(BUFFER *pkt)
{
   return pkt->data[0];
}
//---------------------------------------------------------------------------
bool __fastcall TPgpMsg::IsConventional()
{
  int type; long l;
  type = pgp_packettype(buf, &l); buf_rewind(buf);
  return (type == PGP_ENCRYPTED);
}
//---------------------------------------------------------------------------
/*int __fastcall TPgpMsg::GetMPI(BUFFER *mpi)
{
  int l=buf_geti(msg);
  if (l <= 0 || msg->ptr + (l + 7) / 8 > msg->length) return (-1);
  buf_get(msg, mpi, (l + 7) / 8);
  return (l);
}
//---------------------------------------------------------------------------
int __fastcall TPgpMsg::PutMPI(BUFFER *buf, BUFFER *mpi)
{
  int l,i;
  l = mpi->length * 8;
  for (i = 7; i >= 0; i--)
    if (((mpi->data[0] >> i) & 1) == 1) {
      l -= 7 - i;
      break;
    }
  buf_appendi(buf, l);
  buf_cat(buf, mpi);
  return (l);
}*/
//---------------------------------------------------------------------------
